import os ,shutil
import numpy as np 
from keras.applications import MobileNet
from keras import models
from keras import layers
from keras.preprocessing.image import image
from keras import optimizers ,regularizers
import h5py
from keras.models import model_from_json


#assume paper cups = 1 and reusabe_cups=0
paper_cups = '/home/chirag/Paper_coffee_cups'
reusable_cups = '/home/chirag/other_coffee_cups'

base_dir = '/home/chirag/project'


train_features = np.zeros((210,128,128,3))
train_labels = np.zeros(210)


validation_features = np.zeros((90,128,128,3))
validation_labels = np.zeros(90)
#first shuffle the images in both categories
#print(len(os.listdir(paper_cups)))
indices1 = np.arange(1,len(os.listdir(paper_cups)) + 1)
np.random.shuffle(indices1)
#print(i)
indices2 = np.arange(1,len(os.listdir(reusable_cups)) + 1)
np.random.shuffle(indices2)

#make train,validation and test directories

train_dir = os.path.join(base_dir,'train')
os.mkdir(train_dir)

train_paper = os.path.join(train_dir,'paper')
os.mkdir(train_paper)

train_reuse = os.path.join(train_dir,'reuse')
os.mkdir(train_reuse)
 
validation_dir = os.path.join(base_dir,'validation')
os.mkdir(validation_dir)

validation_paper = os.path.join(validation_dir,'paper')
os.mkdir(validation_paper)

validation_reuse = os.path.join(validation_dir,'reuse')
os.mkdir(validation_reuse)

test_dir = os.path.join(base_dir,'test')
os.mkdir(test_dir)


test_paper = os.path.join(test_dir,'paper')
os.mkdir(test_paper)

test_reuse = os.path.join(test_dir,'reuse')
os.mkdir(test_reuse)


fnames1 = ['paper_{}.jpg'.format(i) for i in indices1[:105]]

for fname in fnames1:
	src = os.path.join(paper_cups,fname)
	dst = os.path.join(train_paper,fname)
	shutil.copyfile(src,dst)


#this is for reusable coffee cups
fnames2 = ['reuse_{}.jpg'.format(i) for i in indices2[:105]]

for fname in fnames2:
	src = os.path.join(reusable_cups,fname)
	dst = os.path.join(train_reuse,fname)
	shutil.copyfile(src,dst)

#now preparing training features , train labels and valid_features and valid_labels

n = len(os.listdir(train_paper))


fnames1 = [os.path.join(train_paper,fname) for fname in os.listdir(train_paper)]
for i in range(n):
	img_path = fnames1[i]  
	img = image.load_img(img_path,target_size=(128,128))
	x = image.img_to_array(img)
	#print("Before normalization")
	#print(x)
	#x = x.reshape((1,) + x.shape)
	x /= 255.
	#print("\nAfter normalization")
	#print(x)
	#print(x.shape)
	train_features[i] = x
	train_labels[i] = 1



fnames2 = [os.path.join(train_reuse,fname) for fname in os.listdir(train_reuse)]
for i in range(n):
	img_path = fnames2[i]  
	img = image.load_img(img_path,target_size=(128,128))
	x = image.img_to_array(img)
	#print(x)
	#x = x.reshape((1,) + x.shape)
	#print(x.shape)
	#normalize here by dividing by 255.
	x /= 255.
	#print(x)
	train_features[n + i] = x
	#train_labels[105 + i] = 0




fnames1 = ['paper_{}.jpg'.format(i) for i in indices1[105:]]

for fname in fnames1:
	src = os.path.join(paper_cups,fname)
	dst = os.path.join(validation_paper,fname)
	shutil.copyfile(src,dst)


fnames2 = ['reuse_{}.jpg'.format(i) for i in indices1[105:]]

for fname in fnames2:
	src = os.path.join(reusable_cups,fname)
	dst = os.path.join(validation_reuse,fname)
	shutil.copyfile(src,dst)
#print(len(fnames))





n1 = len(os.listdir(validation_paper))


fnames1 = [os.path.join(validation_paper,fname) for fname in os.listdir(validation_paper)]
for i in range(n1):
	img_path = fnames1[i]  
	img = image.load_img(img_path,target_size=(128,128))
	x = image.img_to_array(img)
	#print("Before normalization")
	#print(x)
	#x = x.reshape((1,) + x.shape)
	x /= 255.
	#print("\nAfter normalization")
	#print(x)
	#print(x.shape)
	validation_features[i] = x
	validation_labels[i] = 1



fnames2 = [os.path.join(validation_reuse,fname) for fname in os.listdir(validation_reuse)]
for i in range(n1):
	img_path = fnames2[i]  
	img = image.load_img(img_path,target_size=(128,128))
	x = image.img_to_array(img)
	#print(x)
	#x = x.reshape((1,) + x.shape)
	#print(x.shape)
	#normalize here by dividing by 255.
	x /= 255.
	#print(x)
	train_features[n1 + i] = x
	#train_labels[105 + i] = 0
#n = len(os.listdir(train_paper))





#using python generator to generate images in batches of 16 * 10 = 160

#generators are now not required



# train_gen = ImageDataGenerator(rescale = 1. /255,

# 		#rotation_range = 40,
# 		#width_shift_range = 0.2,
# 		#height_shift_range=0.2,
# 		#shear_range=0.2,
# 		#zoom_range=0.2,
# 		#horizontal_flip=True,
# 		#fill_mode='nearest'
# 		)




# test_datagen = ImageDataGenerator(rescale = 1. / 255,
# 	)


# train_generator = train_gen.flow_from_directory(
# 	train_dir,
# 	target_size = (128,128),
# 	batch_size = 210, # hardcoded for training samples 
# 	classes = ['paper','reuse'],
# 	class_mode='binary'
# 	)

# #generate a validation generator
# validation_generator = train_gen.flow_from_directory(
# 	validation_dir,
# 	target_size = (128,128),
# 	batch_size = 90, #hardcoded for validation examples
# 	classes = ['paper','reuse'],
# 	class_mode='binary'
# 	)

#start shuffline train_features and validation_features
indices3 = np.arange(0,len(train_features))
np.random.shuffle(indices3)

train_features = train_features[indices3]
train_labels = train_labels[indices3]



indices4 = np.arange(0,len(validation_features))
np.random.shuffle(indices4)

validation_features = validation_features[indices4]
validation_labels = validation_labels[indices4]


#defining the MobileNet model

#feature extraction for our coffe cups classification
conv_base = MobileNet(weights = 'imagenet',include_top=False,input_shape=(128,128,3),alpha=1.0, depth_multiplier=1, classes=2)


#the last dense classifier needs to be adjusted for the machine learning problem at hand
#so need to unfreeze just the dense classifier

model = models.Sequential()
model.add(conv_base)
model.add(layers.GlobalAveragePooling2D(data_format=None))
#model.add(layers.Flatten())
#model.add(layers.Dropout(0.5))
#model.add(layers.Dropout(0.5))
#model.add(layers.Dense(256,activation='relu'))
#model.add(layers.Dense(16,activation='relu',kernel_regularizer=regularizers.l2(0.001)))
#model.add(layers.Dropout(0.5))
model.add(layers.Dense(1,activation='sigmoid',kernel_regularizer=regularizers.l2(0.01)))

model.summary()

conv_base.trainable = False   # this freezes the weights of the conv_base



#now compile the model
model.compile(optimizer='rmsprop',loss='binary_crossentropy',metrics=['acc'])






#now train the network
history = model.fit(train_features,train_labels,epochs=20,batch_size=210,validation_data=(validation_features,validation_labels))




#save the model now 
#model.save('MobileNetV2_model.hdf5',include_optimizer=False)  #dense layer with 64 neuron gives the best results in k fold validation

model_json = model.to_json()
with open("model.json", "w") as json_file:
	json_file.write(model_json)
	#serialize weights to HDF5
model.save_weights("weights.h5")
print("Saved model to disk")



#save the model
#model.save('coffee_cup_classification.h5')
#plotting loss and accuracy plots using matplotlib
import matplotlib.pyplot as plt 
acc = history.history['acc']
val_acc = history.history['val_acc']

loss = history.history['loss']
val_loss = history.history['val_loss']

epochs = range(1,len(val_loss) + 1 )


plt.plot(epochs,acc,'bo',label= 'Training accuracy')
plt.plot(epochs,val_acc,'b',label='Validation accuracy')
plt.xlabel('Epochs')
plt.ylabel('Accuracy')
plt.title('Training and Validation accuracy')
plt.legend()

plt.figure()
plt.plot(epochs,loss,'bo',label= 'Training loss')
plt.plot(epochs,val_loss,'b',label='Validation loss')
plt.xlabel('Epochs')
plt.ylabel('Loss')
plt.title('Training and Validation losses')
plt.legend()

plt.show()



#output = model.predict(test_image.reshape(1, 28, 28, 1))[0]
#print("Keras \r\n", output, '\r\nPredicted:',output.argmax())